#!/bin/bash 

uImage="/unit_tests/uImage" 
uBoot="/unit_tests/u-boot.imx" 
transformerHD_FW="/unit_tests/transformerHD_FW.out" 
rootfs="/unit_tests/rootfs.tar.bz2" 
dtb_MA="/unit_tests/imx6dl-sabresd.dtb"
dtb_AR="/unit_tests/imx6dl-sabresd-ar1335.dtb" 

chmod -R 777 /unit_tests/ 

#create a separate partition 
mkdir -p /mnt/mmcblk0p2 

#mount the partition 
mount -t ext3 /dev/mmcblk0p2 /mnt/mmcblk0p2 

cp /unit_tests/led.out /mnt/mmcblk0p2 

cp /unit_tests/memtool /mnt/mmcblk0p2 

#run the script in background 
/mnt/mmcblk0p2/led.out & 

if [ -f "$uBoot" ] || [ -f "$uImage" ] 
then 
dd if=/dev/zero of=/dev/mmcblk0 bs=1k seek=384 conv=fsync count=129
fi 

if [ -f "$uBoot" ] 
then 
echo 0 > /sys/block/mmcblk0boot0/force_ro 
dd if=/unit_tests/u-boot.imx of=/dev/mmcblk0boot0 bs=512 seek=2 
echo 1 > /sys/block/mmcblk0boot0/force_ro 
else 
echo "No Need to upgrade u-boot..." 
fi 

if [ -f "$uImage" ] 
then 
echo 8 > /sys/block/mmcblk0/device/boot_config 
mkdir -p /mnt/mmcblk0p1 
mount -t vfat /dev/mmcblk0p1 /mnt/mmcblk0p1 
cp /unit_tests/uImage /mnt/mmcblk0p1/uImage 
umount /mnt/mmcblk0p1 
else 
echo "No Need to upgrade uImage..." 
fi 

if [ -f "$dtb_MA" ] 
then 
echo 8 > /sys/block/mmcblk0/device/boot_config 
mkdir -p /mnt/mmcblk0p1 
mount -t vfat /dev/mmcblk0p1 /mnt/mmcblk0p1 
cp /unit_tests/imx6dl-sabresd.dtb /mnt/mmcblk0p1/imx6dl-sabresd.dtb 
umount /mnt/mmcblk0p1 
echo "dtb_MA upgrade completed" 
else 
echo "No Need to upgrade dtb_MA..." 
fi 

if [ -f "$dtb_AR" ] 
then 
echo 8 > /sys/block/mmcblk0/device/boot_config 
mkdir -p /mnt/mmcblk0p1 
mount -t vfat /dev/mmcblk0p1 /mnt/mmcblk0p1 
cp /unit_tests/imx6dl-sabresd-ar1335.dtb /mnt/mmcblk0p1/imx6dl-sabresd-ar1335.dtb
umount /mnt/mmcblk0p1 
echo "dtb_AR upgrade completed" 
else 
echo "No Need to upgrade dtb_AR..." 
fi 

if [ -f "$transformerHD_FW" ] 
then 
echo "updating transformerHD application...." 
rm /unit_tests/transformerHD.out 
mv /unit_tests/transformerHD_FW.out /unit_tests/transformerHD.out 
else 
echo "transformerHD not found.." 
fi 

if [ -f "$rootfs" ] 
then 
echo "updating rootfs....." 
cp /unit_tests/rootfs.tar.bz2 /mnt/mmcblk0p2 
cp /unit_tests/PowerSettings.ini /mnt/mmcblk0p2 
cp /unit_tests/CameraConfig.ini /mnt/mmcblk0p2 
cp /unit_tests/ProductInfo.ini /mnt/mmcblk0p2 
tar -jxvf /mnt/mmcblk0p2/rootfs.tar.bz2 
cp /mnt/mmcblk0p2/PowerSettings.ini /unit_tests/ 
cp /mnt/mmcblk0p2/CameraConfig.ini /unit_tests/ 
cp /mnt/mmcblk0p2/ProductInfo.ini /unit_tests/ 
rm /mnt/mmcblk0p2/rootfs.tar.bz2 
echo "rootfs update completed......." 
else 
echo "rootfs upgrade not required......" 
fi

umount /mnt/mmcblk0p2 

sync 
rm $uBoot 
rm $uImage 
rm $dtb_MA
rm $dtb_AR 
rm $rootfs 

fw_setenv appreboot 1
fw_printenv appreboot
sync

sleep 1
reboot
